## vowpal-wabbit 8.6.1.dfsg1

=== Makefile ===
CXX ?= $(shell which g++)
# -- if you want to test 32-bit use this instead,
#    it sometimes reveals type portability issues
# CXX = $(shell which g++) -m32
ifneq ($(CXX),)
  #$(warning Using clang: "$(CXX)")
  ARCH = -D__extern_always_inline=inline
else
  CXX = clang++
  $(warning Using clang++)
endif
#ARCH = $(shell test `$CXX -v 2>&1 | tail -1 | cut -d ' ' -f 3 | cut -d '.' -f 1,2` \< 4.3 && echo -march=nocona || echo -march=native)

ifeq ($(CXX),)
  $(warning No compiler found)
  exit 1
endif

UNAME := $(shell uname)
ARCH_UNAME := $(shell uname -m)
LIBS = -l boost_program_options -l pthread -l z
BOOST_INCLUDE = -I /usr/local/include/boost -I /usr/include
BOOST_LIBRARY = -L /usr/local/lib -L /usr/lib
NPROCS := 1

ifeq ($(UNAME), Linux)
  BOOST_LIBRARY += -L /usr/lib/x86_64-linux-gnu
  NPROCS:=$(shell grep -c ^processor /proc/cpuinfo)
endif
ifeq ($(UNAME), FreeBSD)
  LIBS = -l boost_program_options -l pthread -l z -l compat
  BOOST_INCLUDE = -I /usr/local/include
  NPROCS:=$(shell grep -c ^processor /proc/cpuinfo)
endif
ifeq "CYGWIN" "$(findstring CYGWIN,$(UNAME))"
  LIBS = -l boost_program_options-mt -l pthread -l z
  BOOST_INCLUDE = -I /usr/include
  NPROCS:=$(shell grep -c ^processor /proc/cpuinfo)
endif
ifeq ($(UNAME), Darwin)
  LIBS = -lboost_program_options-mt -lboost_serialization-mt -l pthread -l z
  # On Macs, the location isn't always clear
  #	brew uses /usr/local
  #	but /opt/local seems to be preferred by some users
  #	so we try them both
  ifneq (,$(wildcard /usr/local/include))
    BOOST_INCLUDE = -I /usr/local/include
    BOOST_LIBRARY = -L /usr/local/lib
  endif
  ifneq (,$(wildcard /opt/local/include))
    BOOST_INCLUDE = -I /opt/local/include
    BOOST_LIBRARY = -L /opt/local/lib
  endif
  NPROCS:=$(shell sysctl -n hw.ncpu)
endif

ifneq ($(USER_BOOST_INCLUDE),)
  BOOST_INCLUDE = $(USER_BOOST_INCLUDE)
endif
ifneq ($(USER_BOOST_LIBRARY),)
  BOOST_LIBRARY = $(USER_BOOST_LIBRARY)
endif


JSON_INCLUDE = -I ../rapidjson/include

#LIBS = -l boost_program_options-gcc34 -l pthread -l z

ifeq ($(ARCH_UNAME), ppc64le)
  OPTIM_FLAGS ?= -DNDEBUG -O3 -fomit-frame-pointer -fno-strict-aliasing #-msse2 is not supported on power
else
  OPTIM_FLAGS ?= -DNDEBUG -O3 -fomit-frame-pointer -fno-strict-aliasing -msse2 -mfpmath=sse #-ffast-math #uncomment for speed, comment for testability
endif

ifeq ($(UNAME), FreeBSD)
  WARN_FLAGS = -Wall
else
  WARN_FLAGS = -Wall -pedantic
endif

# for normal fast execution.
FLAGS = -std=c++11 $(CFLAGS) $(LDFLAGS) $(ARCH) $(WARN_FLAGS) $(OPTIM_FLAGS) -D_FILE_OFFSET_BITS=64 $(BOOST_INCLUDE) $(JSON_INCLUDE) -fPIC #-DVW_LDA_NO_SSE

# for profiling -- note that it needs to be gcc
#FLAGS = -std=c++11 $(CFLAGS) $(LDFLAGS) $(ARCH) $(WARN_FLAGS) -O2 -fno-strict-aliasing -D_FILE_OFFSET_BITS=64 $(BOOST_INCLUDE) $(JSON_INCLUDE) -pg  -fPIC
#CXX = g++

# for valgrind / gdb debugging
#FLAGS = -std=c++11 $(CFLAGS) $(LDFLAGS) $(ARCH) $(WARN_FLAGS) -D_FILE_OFFSET_BITS=64 $(BOOST_INCLUDE) $(JSON_INCLUDE) -g -O0  -fPIC

# for valgrind profiling: run 'valgrind --tool=callgrind PROGRAM' then 'callgrind_annotate --tree=both --inclusive=yes'
#FLAGS = -std=c++11 $(CFLAGS) $(LDFLAGS) -Wall $(ARCH) -ffast-math -D_FILE_OFFSET_BITS=64 $(BOOST_INCLUDE) $(JSON_INCLUDE)  -g -fomit-frame-pointer -ffast-math -fno-strict-aliasing  -fPIC

FLAGS += -I ../rapidjson/include -I ../explore
BINARIES = vw active_interactor
MANPAGES = vw.1

default:	vw

all:	vw library_example java spanning_tree rl_clientlib

%.1:	%
	help2man --no-info --name="Vowpal Wabbit -- fast online learning tool" ./$< > $@

export

rl_clientlib:
	cd reinforcement_learning/rlclientlib; $(MAKE) -j $(NPROCS) things

rl_clientlib_test: vw rl_clientlib
	cd reinforcement_learning/unit_test; $(MAKE) -j $(NPROCS) things
	(cd reinforcement_learning/unit_test && ./rlclient-test.out)

rl_example: vw rl_clientlib
	cd reinforcement_learning/examples/basic_usage_cpp; $(MAKE) -j $(NPROCS) things
	cd reinforcement_learning/examples/rl_sim_cpp; $(MAKE) -j $(NPROCS) things

spanning_tree:
	cd cluster; $(MAKE)

vw:
	cd vowpalwabbit; $(MAKE) -j $(NPROCS) things

#Target-specific flags for a profiling build.  (Copied from line 70)
vw_gcov: FLAGS = -std=c++11 $(CFLAGS) $(LDFLAGS) $(ARCH) $(WARN_FLAGS) -g -O0 -fprofile-arcs -ftest-coverage -fno-strict-aliasing -D_FILE_OFFSET_BITS=64 $(BOOST_INCLUDE) $(JSON_INCLUDE) -I ../explore -pg  -fPIC #-DVW_LDA_NO_S
vw_gcov: CXX = g++
vw_gcov:
	cd vowpalwabbit && env LDFLAGS="-fprofile-arcs -ftest-coverage -lgcov"; $(MAKE) -j $(NPROCS) things

active_interactor:
	cd vowpalwabbit; $(MAKE)

library_example: vw
	cd library; $(MAKE) -j $(NPROCS) things

#Target-specific flags for a profiling build.  (Copied from line 70)
library_example_gcov: FLAGS = -std=c++11 $(CFLAGS) $(LDFLAGS) $(ARCH) $(WARN_FLAGS) -g -O0 -fprofile-arcs -ftest-coverage -fno-strict-aliasing -D_FILE_OFFSET_BITS=64 $(BOOST_INCLUDE) $(JSON_INCLUDE) -I ../explore -pg  -fPIC #-DVW_LDA_NO_S
library_example_gcov: CXX = g++
library_example_gcov: vw_gcov
	cd library && env LDFLAGS="-fprofile-arcs -ftest-coverage -lgcov"; $(MAKE) things

python: vw
	cd python; $(MAKE) things

java: vw
	cd java; $(MAKE) things

.FORCE:

test: .FORCE vw library_example
	@echo "vw running test-suite..."
	(cd test && ./RunTests -d -fe -E 0.001 -O --onethread ../vowpalwabbit/vw)
	(cd test && ./RunTests -d -fe -E 0.001 ../vowpalwabbit/vw)
	cd test && python save_resume_test.py --verbose_on_fail

test_gcov: .FORCE vw_gcov library_example_gcov
	@echo "vw running test-suite..."
	(cd test && ./RunTests -d -fe -E 0.001 ../vowpalwabbit/vw ../vowpalwabbit/vw)

bigtests:	.FORCE vw
	(cd big_tests && $(MAKE) $(MAKEFLAGS))

install: $(BINARIES)
	cd vowpalwabbit; cp $(BINARIES) /usr/local/bin; cd ../cluster; $(MAKE) install; cd ../java; $(MAKE) install;

doc:
	(cd doc && doxygen Doxyfile)

clean:
	cd vowpalwabbit && $(MAKE) clean
	cd cluster && $(MAKE) clean
	cd library && $(MAKE) clean
	cd python  && $(MAKE) clean
	cd java    && $(MAKE) clean
	cd reinforcement_learning/rlclientlib    && $(MAKE) clean
	cd reinforcement_learning/unit_test; $(MAKE) clean
	cd reinforcement_learning/examples/basic_usage_cpp; $(MAKE) clean
	cd reinforcement_learning/examples/rl_sim_cpp; $(MAKE) clean

.PHONY: all clean install doc

=== big_tests/Makefile ===
# Makefile for big_tests

SHELL = bash

# suppress built-in rules, to speed things up
MAKEFLAGS+=r
# disable implicit suffixes, to speed things up
.SUFFIXES:
# keep all intermediate files
.SECONDARY:
.SECONDEXPANSION:
# .ONESHELL doesn't work with make < 3.82!
# .ONESHELL:

# comment out for debugging
.SILENT:

# can't compare before running; can't prep data before downloading; etc.
.NOTPARALLEL:

.PHONY:	default all stub help valid expected pretend run startTimer clean spotless %.valid %.expected %.run %.clean %.deps %.depsWrapper %.depsStart %.depsEnd %.stub

TOP_MK_DIR := $(patsubst %/,%,$(dir $(CURDIR)/$(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))))

ifdef TIMING
TIMING_SUFFIX = WithTiming
MIPS_HELP := $(shell lscpu | grep -i bogomips)
MIPS := $(word $(words $(MIPS_HELP)),$(MIPS_HELP))
ARCH ?= $(subst /,_,$(shell uname -o)_$(MIPS))
# can't use the architecture as directory name, cuz that produces different expected files on different platforms
# stageDir := $(ARCH)
TIME ?= env time -f "%U"
TIME_DIFF_TOLERANCE_REL ?= 0.05
TIME_DIFF_TOLERANCE_ABS ?= 1.0
endif

stageDir ?= runs
dataDir ?= dataSets
expDir ?= expected
testCodeDir := $(TOP_MK_DIR)/testCode

allTests := $(patsubst %/,%,$(shell ls $(expDir)))
# allTests := 2

# the ?= allows the user to override the executable from the command line, as in
# make EXEC=myProgram all
# alas, $(realpath ...) doesn't seem to work here on make 3.81 for some reason
EXEC ?= ../vowpalwabbit/vw
ACC_DIFF_TOLERANCE_REL ?= 0.001
ACC_DIFF_TOLERANCE_ABS ?= 0.001
DIFF ?= $(testCodeDir)/floatingTolerance.pl
GREP ?= grep
DEFAULT_STDOUT_COMPARATOR_REGEXP ?= "."
DEFAULT_STDERR_COMPARATOR_REGEXP ?= "average loss"
ARF ?= vwBigtests.tz2
# you can uncomment the next line to get the data from a cache by default, but we don't recommend it
URL ?= https://vowpalwabbitdata.blob.core.windows.net/bigtests/vwBigtests.tz2


all:	valid ;

.DEFAULT:
	@echo "No rules found for $@ in $(MAKEFILE_LIST)"

# details of individual tests and test groups come from here
include dataSets.mk
include testDetails.mk
include testGroups.mk

# for debugging
%.stub:
	echo $($*.deps)
	echo $(stageDir)/$*.dir/done
	echo $(addsuffix .valid,$($*.deps))

# for debugging
stub:	
	echo $(TIMING)
	echo $(MAKE_VERSION)
	echo $(ARCH)
	echo $(MAKEFLAGS)
	echo $(EXEC)
	echo $(TOP_MK_DIR)
	echo $(VPATH)

help:
	cat $(TOP_MK_DIR)/README.txt

validTargets := $(addsuffix .valid,$(allTests))
valid:	$(validTargets) timingSummary
	@echo "test suite finished"

# use this target to run without doing any diffs
runTargets := $(addsuffix .run,$(allTests))
run:	prepData $(runTargets) timingSummary
	@echo "'make run' finished"

timingSummary:
	if [ "$(TIMING)" = "y" ] ; then \
		totalTime=0 ;\
		for dir in $(allTests) ; do \
			timeFile=$(stageDir)/$$dir.dir/$(ARCH)/rc ;\
			currTime=`cat $$timeFile` ;\
			totalTime=`echo "$$totalTime + $$currTime" | bc -l` ;\
		done ;\
		echo "Total test time = $$totalTime" ;\
	fi

mcompareTargets := $(addsuffix .compare,$(allTests))
compare:	$(compareTargets)
	@echo "'make compare' finished"

expectedTargets := $(addsuffix .expected,$(allTests))
expected:	$(expectedTargets)
	@echo "'make expected' finished"

pretendTargets := $(addsuffix .pretend,$(allTests))
pretend:	$(pretendTargets)
	@echo "'make pretend' finished"

clean:
	-rm -r $(stageDir)
	@echo "'make clean' finished"

%.dir/$(ARCH) %.dir:
	@mkdir -p $@

%.valid:	%.run %.compare ;

# dependency tracking doesn't work in make < 4 due to a bug in how SECONDEXPANSION is done
ifeq ($(findstring 4.,$(MAKE_VERSION)),4.)
%.run:	 %.depsWrapper $(stageDir)/%.dir/done$(TIMING_SUFFIX) ;
else
%.run:	 $(stageDir)/%.dir/done$(TIMING_SUFFIX) ;
endif

$(dataDir) $(stageDir):
	@mkdir -p $@

%.depsWrapper:	%.depsStart $$(%.deps) %.depsEnd ;

%.depsStart:
	@if [ -n "$($*.deps)" ] ; then \
		echo "test $* has dependencies: $($*.deps)" ;\
	fi

%.depsEnd:
	@if [ -n "$($*.deps)" ] ; then \
		echo "dependencies of test $* satisfied" ;\
	fi

# Don't do like on the following line, because making the dir a dependency of the file that's in it will result in the file always getting remade, cuz the dir will always have a newer timestamp.
# $(stageDir)/%.dir/done:	$(stageDir)/%.dir
$(stageDir)/%.dir/doneWithTiming:	$(EXEC) $$(%.inData)
	@echo "Starting to run test $*"
	dir=`dirname $@` ;\
	mkdir -p $$dir ;\
	exec=$(EXEC) ;\
	if [ -n "$($*.exec)" ] ; then exec="$($*.exec)" ; fi ;\
	roFile=$$dir/raw_out ;\
	reFile=$$dir/raw_err ;\
	oFile=$$dir/out ;\
	eFile=$$dir/err ;\
	mkdir -p $$dir/$(ARCH) ;\
	timeFile=$$dir/$(ARCH)/rc ;\
	echo "$(TIME) -o $$timeFile $$exec $($*.params) $(EP) > $$roFile 2> $$reFile" ;\
	$(TIME) -o $$timeFile $$exec $($*.params) $(EP) > $$roFile 2> $$reFile ;\
	uTime=`cat $$timeFile` ;\
	echo "run time of test $* = $$uTime" ;\
	out_compar=$(DEFAULT_STDOUT_COMPARATOR_REGEXP) ;\
	if [ -n "$($*.STDOUT_COMPARATOR_REGEXP)" ] ; then out_compar="$($*.STDOUT_COMPARATOR_REGEXP)" ; fi ;\
	echo "$(GREP) \"$$out_compar\" $$roFile | tee $$oFile" ;\
	$(GREP) "$$out_compar" $$roFile | tee $$oFile ;\
	err_compar=$(DEFAULT_STDERR_COMPARATOR_REGEXP) ;\
	if [ -n "$($*.STDERR_COMPARATOR_REGEXP)" ] ; then err_compar="$($*.STDERR_COMPARATOR_REGEXP)" ; fi ;\
	echo "$(GREP) \"$$err_compar\" $$reFile | tee $$eFile" ;\
	$(GREP) "$$err_compar" $$reFile | tee $$eFile ;\
	touch $$dir/done
	touch $@
	@echo "Finished running test $*"

$(stageDir)/%.dir/done:	$(EXEC) $$(%.inData)
	@echo "Starting to run test $*"
	dir=`dirname $@` ;\
	mkdir -p $$dir ;\
	exec=$(EXEC) ;\
	if [ -n "$($*.exec)" ] ; then exec="$($*.exec)" ; fi ;\
	roFile=$$dir/raw_out ;\
	reFile=$$dir/raw_err ;\
	oFile=$$dir/out ;\
	eFile=$$dir/err ;\
	echo "$$exec $($*.params) $(EP) > $$roFile 2> $$reFile" ;\
	$$exec $($*.params) $(EP) > $$roFile 2> $$reFile ;\
	out_compar=$(DEFAULT_STDOUT_COMPARATOR_REGEXP) ;\
	if [ -n "$($*.STDOUT_COMPARATOR_REGEXP)" ] ; then out_compar="$($*.STDOUT_COMPARATOR_REGEXP)" ; fi ;\
	echo "$(GREP) \"$$out_compar\" $$roFile | tee $$oFile" ;\
	$(GREP) "$$out_compar" $$roFile | tee $$oFile ;\
	err_compar=$(DEFAULT_STDERR_COMPARATOR_REGEXP) ;\
	if [ -n "$($*.STDERR_COMPARATOR_REGEXP)" ] ; then err_compar="$($*.STDERR_COMPARATOR_REGEXP)" ; fi ;\
	echo "$(GREP) \"$$err_compar\" $$reFile | tee $$eFile" ;\
	$(GREP) "$$err_compar" $$reFile | tee $$eFile ;\
	touch $@
	@echo "Finished running test $*"

# first diff all the results, then set exit status if non-empty
%.compare:	$(DIFF) $(expDir)/%/out $(expDir)/%/err
	dir=$(stageDir)/$*.dir ;\
	rm -f $$dir/diffs ;\
	for FILE in out err $($*.otherOutputs) ; do \
		echo "$(DIFF) $(ACC_DIFF_TOLERANCE_REL) $(ACC_DIFF_TOLERANCE_ABS) $$dir/$$FILE $(expDir)/$*/$$FILE" ;\
		$(DIFF) $(ACC_DIFF_TOLERANCE_REL) $(ACC_DIFF_TOLERANCE_ABS) $$dir/$$FILE $(expDir)/$*/$$FILE |& tee -a $$dir/diffs ;\
	done ;\
	if [ -s $$dir/diffs ] ; then \
		echo "Test $* failed due to accuracy diffs." ;\
		exit 1 ;\
	fi ;\
	if [ "$(TIMING)" = "y" ] ; then \
		timeFile=$$dir/$(ARCH)/rc ;\
		uTime=`cat $$timeFile` ;\
		echo "run time of test $* = $$uTime" ;\
		if [ -s $(expDir)/$*/$(ARCH)/rc ] ; then (\
			echo "$(DIFF) $(TIME_DIFF_TOLERANCE_REL) $(TIME_DIFF_TOLERANCE_ABS) $$timeFile $(expDir)/$*/$(ARCH)/rc" ;\
			$(DIFF) $(TIME_DIFF_TOLERANCE_REL) $(TIME_DIFF_TOLERANCE_ABS) $$timeFile $(expDir)/$*/$(ARCH)/rc |& tee -a $$dir/diffs ;\
			if [ -s $$dir/diffs ] ; then \
				echo "Test $* failed due to speed diffs." ;\
				exit 1 ;\
			fi ;\
		) ;\
		else (\
			echo "WARNING: Missing expected timing file.  You might want to create it with 'make TIMING=y expected'.  Timing validation skipped." \
		) ; \
		fi ;\
	fi

# update expected files from current output files
# expected files always include out and err
%.expected:
	dir=$(stageDir)/$*.dir ;\
	mkdir -p $(expDir)/$*/ ;\
	for FILE in out err $($*.otherOutputs) ; do \
		(echo "copying $$dir/$$FILE to $(expDir)/$*/" ; cp $$dir/$$FILE $(expDir)/$*/ ) ;\
	done ;\
	if [ "$(TIMING)" = "y" ] ; then \
		mkdir -p $(expDir)/$*/$(ARCH) ;\
		(echo "copying $$dir/$(ARCH)/rc to $(expDir)/$*/$(ARCH)/rc" ; cp $$dir/$(ARCH)/rc $(expDir)/$*/$(ARCH)/rc ) ;\
	fi

# copy outputs from expected files, to pretend that the module succeeded
%.pretend:	$(stageDir)/%.dir $(expDir)/%/out $(expDir)/%/err
	dir=$(stageDir)/$*.dir ;\
	for FILE in out err $($*.otherOutputs) ; do \
		echo "copying $(expDir)/$*/$$FILE to $$dir/" ;\
		cp $(expDir)/$*/$$FILE $$dir/ ;\
	done ;\
	touch $$dir/done ;\
	if [ "$(TIMING)" = "y" ] ; then \
		mkdir -p $$dir/$(ARCH) ;\
		echo "copying $(expDir)/$*/$(ARCH)/rc $$dir/$(ARCH)/rc" ;\
		cp $(expDir)/$*/$(ARCH)/rc $$dir/$(ARCH)/rc ;\
	fi

%.clean:
	-rm -rf $(stageDir)/$*.dir
	@echo "finished cleaning $(stageDir)/$*.dir"

=== cluster/Makefile ===
CXX ?= $(shell which g++)
ifneq ($(CXX),)
  #$(warning Using clang: "$(CXX)")
  ARCH = -D__extern_always_inline=inline
else
  CXX = g++
#  $(warning Using g++)
ARCH = $(shell test `g++ -v 2>&1 | tail -1 | cut -d ' ' -f 3 | cut -d '.' -f 1,2` \< 4.3 && echo -march=nocona || echo -march=native)
endif

ifeq ($(CXX),)
  $(error No compiler found)
endif

FLAGS += -I ../vowpalwabbit 
STDLIBS = $(BOOST_LIBRARY) $(LIBS)

all:	spanning_tree

%.o:	 %.cc  %.h
	$(CXX) $(FLAGS) -c $< -o $@

%.o:	 %.cc
	$(CXX) $(FLAGS) -c $< -o $@

spanning_tree: spanning_tree_main.o ../vowpalwabbit/spanning_tree.o ../vowpalwabbit/vw_exception.o
	$(CXX) $(FLAGS) -o $@ $+ $(STDLIBS) 

install: spanning_tree
	cp spanning_tree /usr/local/bin

clean:
	rm -f  *.o $(BINARIES) *~ $(MANPAGES)

=== doc/Makefile ===
doc:
	cd ..; make doc ; cd doc

=== python/Makefile ===
#
# Critical variables are passed recursively (via the environment)
# by the top level Makefile when calling $(MAKE)
#
# If we don't know where to look for boost - it's a no go.
#
#ifeq ($(BOOST_LIBRARY),)
#  $(error Please run 'make' at the top level only)
#endif

# When using setup.py to install the PYTHON_* env vars are resolved and set automatically

# When running make directly PYTHON_VERSION and PYTHON_LIBS env vars can be set to change these defaults.
# For Python 3 one should find the version of libboost-python-dev installed locally as it may not be in
# sync with the python version. For example, on Ubuntu 14.04 apt-get installs libboost_python-py34.so.*
# and for that the setting required is PYTHON_LIBS="-l boost_python-py34".
ifeq ($(PYTHON_VERSION),)
  PYTHON_VERSION = 2.7
endif

ifeq ($(PYTHON_LIBS),)
  PYTHON_LIBS = -l boost_python
endif

ifeq ($(PYTHON_INCLUDE),)
    PYTHON_INCLUDE = $(shell python$(PYTHON_VERSION)-config --includes)
endif

ifeq ($(PYTHON_LDFLAGS),)
    PYTHON_LDFLAGS = $(shell python$(PYTHON_VERSION)-config --ldflags)
endif

JSON_INCLUDE = -I ../rapidjson/include 

ifeq (,$(wildcard ../vowpalwabbit/vw.so))
  VWLIBS = ../vowpalwabbit/libvw.a ../vowpalwabbit/liballreduce.a
else
  VWLIBS = -L ../vowpalwabbit -l vw -l allreduce
endif
PYLIBVW = pylibvw.so

all:
	cd ..; $(MAKE) python

things: $(PYLIBVW)

ifeq "CYGWIN" "$(findstring CYGWIN,$(UNAME))"
  ifeq ($(PYTHON_LIBS),)
    PYTHON_LIBS = -l boost_python-mt
  endif
  PYLIBVW = pylibvw.dll
endif
ifneq ($(UNAME), Darwin)
  EXPORT_DYNAMIC = -Wl,--export-dynamic
endif

STDLIBS = $(BOOST_LIBRARY) $(LIBS) $(PYTHON_LIBS)

$(PYLIBVW): pylibvw.o  ../vowpalwabbit/libvw.a
	$(CXX) -shared $(EXPORT_DYNAMIC) pylibvw.o $(BOOST_LIBRARY) $(PYTHON_LDFLAGS) $(VWLIBS) $(STDLIBS) -o $(PYLIBVW)

pylibvw.o: pylibvw.cc
	$(info Using Python $(PYTHON_VERSION))
	$(CXX) -std=c++0x $(PYTHON_INCLUDE) $(BOOST_INCLUDE) $(JSON_INCLUDE) -I ../explore -fPIC -c pylibvw.cc -o pylibvw.o

clean:
	rm -f *.o $(PYLIBVW)

.PHONY: all clean things

=== vowpalwabbit/Makefile ===
BINARIES = vw active_interactor
MANPAGES = vw.1

VWLIBS := -L. -l vw -l allreduce
STDLIBS = $(BOOST_LIBRARY) $(LIBS)


all:
	cd ..; $(MAKE)

test:
	cd ..; $(MAKE) test

things:	config.h $(BINARIES)

%.1:	%
	help2man --no-info --name="Vowpal Wabbit -- fast online learning tool" ./$< > $@

config.h: ../configure.ac
	echo \#define PACKAGE_VERSION \"`grep AC_INIT ../configure.ac | cut -d '[' -f 3 | cut -d ']' -f 1`\" > config.h

vw_SOURCES = $(shell grep libvw_la_SOURCES Makefile.am | cut -d '=' -f 2)
vw_OBJECTS = $(patsubst %.cc,%.o,$(vw_SOURCES))
vw_DEPS = $(patsubst %.cc,%.d,$(vw_SOURCES))

allreduce_SOURCES = $(shell grep liballreduce_la_SOURCES Makefile.am | cut -d '=' -f 2)
allreduce_OBJECTS = $(patsubst %.cc,%.o,$(allreduce_SOURCES))

%.d:	%.cc config.h
	$(CXX) -std=c++0x $(BOOST_INCLUDE) -I /usr -I ../rapidjson/include -I ../explore -MM $< > $@
# Do NOT  make dependency files if clean has been called
ifneq ($(MAKECMDGOALS),clean)
  -include $(vw_DEPS)
endif

%.o:	 %.cc  %.h
	$(CXX) $(FLAGS) -c $< -o $@

%.o:	 %.cc
	$(CXX) $(FLAGS) -c $< -o $@

liballreduce.a: $(allreduce_OBJECTS)
	ar rcs $@ $+

libvw.a: $(filter-out vw.o,$(vw_OBJECTS))
	ar rcs $@ $+

vw: main.o libvw.a liballreduce.a
	$(CXX) $(FLAGS) -o $@ $< $(VWLIBS) $(STDLIBS)

active_interactor: active_interactor.cc
	$(CXX) $(FLAGS) -o $@ $+

install: $(BINARIES)
	cp $(BINARIES) /usr/local/bin; cd cluster; $(MAKE) install; cd java; $(MAKE) install

clean:
	rm -f  *.o *.d $(BINARIES) *~ $(MANPAGES) libvw.a liballreduce.a

python: vw
	cd .. ; $(MAKE) python

.PHONY: all clean install test things

=== demo/random-noise/Makefile ===

all::
	@echo === This demo is interactive: hit enter to move to next step
	./vw-demo

=== demo/recall_tree/Makefile ===
.SECONDARY:

bits?=26
passes?=80

defaults: defaults.vw aloi_test.vw.gz
	zcat $(word 2,$^) | sed 's/|/|f/' | ../../vowpalwabbit/vw -t -i $< 

defaults.vw: aloi_train.vw.gz
	zcat $< | sed 's/|/|f/' | ../../vowpalwabbit/vw -f $@ -k -c --passes $(passes) --recall_tree 1000 -b $(bits) --loss_function logistic -q'\x88': -l 1

tuned: tuned.vw aloi_test.vw.gz
	zcat $(word 2,$^) | sed 's/|/|f/' | ../../vowpalwabbit/vw -t -i $< 

tuned.vw: aloi_train.vw.gz
	zcat $< | sed 's/|/|f/' | ../../vowpalwabbit/vw -f $@ -k -c --passes $(passes) --recall_tree 1000 -b $(bits) --loss_function logistic -q'\x88': -l 0.85 --randomized_routing 1 --max_depth 12 --max_candidates 58 --bern_hyper 0.01

aloi_test.vw.gz:
	wget http://lowrank.net/nikos/aloi_test.vw.gz

aloi_train.vw.gz:
	wget http://lowrank.net/nikos/aloi_train.vw.gz

oaa: oaa.vw aloi_test.vw.gz
	vw -t -i $^

oaa.vw: aloi_train.vw.gz
	vw -f $@ -k -c --passes $(passes) --oaa 1000 $< -b $(bits) -l 1.86

=== reinforcement_learning/rlclientlib/Makefile ===
TARGET = librlclient.a
ARFLAGS = rcs 

INCLUDE = -I ../include -I ../../explore -I ../explore -I ../../rapidjson/include -I ./

.PHONY: default all clean

default: $(TARGET)
all: default

things: all

SOURCES = $(filter-out main.cc, $(wildcard *.cc)) $(wildcard */*.cc)
OBJECTS = $(patsubst %.cc, %.o, $(SOURCES))
HEADERS = $(wildcard *.h)

%.o: %.cc $(HEADERS)
	$(CXX) $(FLAGS) $(INCLUDE) -c $< -o $@

.PRECIOUS: $(TARGET) $(OBJECTS)

$(TARGET): $(OBJECTS)
	ar $(ARFLAGS) $@ $(OBJECTS) 

clean:
	-rm -f *.o
	-rm -f $(TARGET)

=== reinforcement_learning/unit_test/Makefile ===
TARGET = rlclient-test.out

RL_LIB = -L ../rlclientlib -lrlclient 
VW_LIB = -L../../vowpalwabbit -lvw -lallreduce
BOOST_LIBS = -lboost_unit_test_framework -lboost_system 
CPPREST_LIBS = -lcpprest -lssl -lcrypto -pthread -ldl 
ALL_LIBS = $(RL_LIB) $(VW_LIB) $(BOOST_LIBS) $(CPPREST_LIBS) $(LIBS)

INCLUDE = -I ../include -I ../rlclientlib -I ../explore -I ../../explore

.PHONY: default all clean

default: $(TARGET)
all: default

things: all

SOURCES = $(wildcard *.cc) http_server/http_server.cc #$(wildcard */*.cc)
OBJECTS = $(patsubst %.cc, %.o, $(SOURCES))
HEADERS = $(wildcard *.h)

%.o: %.cc $(HEADERS)
	$(CXX) $(FLAGS) $(INCLUDE) -c $< -o $@

.PRECIOUS: $(TARGET) $(OBJECTS)

$(TARGET): $(OBJECTS)
	$(CXX) $(FLAGS) $(OBJECTS) $(LIBDIR) $(ALL_LIBS) -Wall -o $@

clean:
	-rm -f *.o
	-rm -f $(TARGET)

=== demo/recall_tree/imagenet/Makefile ===
SHELL=/bin/zsh

numlabels=21841
bits?=30

.SECONDARY:

training.txt.gz:
	wget --tries=100 -c http://hunch.net/~jl/datasets/imagenet/training.txt.gz 
#	ln -s /data/jcl/training.txt.gz

testing.txt.gz:
	wget --tries=100 -c http://hunch.net/~jl/datasets/imagenet/testing.txt.gz 
#	ln -s /data/jcl/testing.txt.gz

full_oaa_hyper%: full_oaa_hyper%.vw testing.txt.gz
	time ./do-oaa-hogwild $(word 2,$^) -i $< -t 

full_oaa_hyper%.vw: training.txt.gz
	perl -le 'BEGIN { srand $*; };			\
	      1; $$eta = 0.1 + 3.9 * rand ();		\
	      1; print join " ", $$eta;' | \
	while read eta ;		\
	  do (						\
	    echo $$eta ;	\
            ./do-oaa-hogwild $< -f $@ --oaa $(numlabels) --oaa_subsample 1000 -b $(bits) --loss_function logistic -l $$eta ; \
	     ) \
	  done #> full_oaa_hyper$*.train 2>&1;		\


oaa_hyper%: training.txt.gz
	perl -le 'BEGIN { srand $*; };			\
	      1; $$eta = 0.1 + 3.9 * rand ();		\
	      1; print join " ", $$eta;' | \
	while read eta ;		\
	  do (						\
	    echo $$eta ;	\
            vw <(zcat $< | head -500000) --oaa $(numlabels) --oaa_subsample 1000 -b $(bits) --loss_function logistic -l $$eta ; \
	     ) > $@ 2>&1;				\
	  done

timefufull_hyper%: full_hyper%.vw testing.txt.gz
	(time vw -t -i $< <(zcat $(word 2,$^) | head -10000); time vw -t -i $< <(zcat $(word 2,$^) | head -20000)) > $@ 2>&1

full_hyper%: full_hyper%.vw testing.txt.gz
	(time vw -t -i $(word 1,$^) <(zcat $(word 2,$^) | sed 's/|/|b/')) > $@ 2>&1

full_hyper%.vw: training.txt.gz
	perl -le 'BEGIN { srand $*; };			\
	      1; $$eta = 0.1 + 3.9 * rand ();		\
	      1; $$depth = int (11 + 6 * rand ());	\
	      1; $$mc = int (20 + 80 * rand ());	\
	      1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
	      1; $$rr = rand () > 0.5 ? 1 : 0;		\
	      1; $$dq = rand () > 0.5 ? "a" : "b";	\
	      1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$dq;' | \
	while read eta depth mc hyper rr dq;		\
	  do (						\
	    echo $$eta $$depth $$mc $$hyper $$rr $$dq;	\
	    vw -f $@ --recall_tree $(numlabels) <(zcat $< | sed 's/|/|b/') -b $(bits) --loss_function logistic -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --link glf1 --randomized_routing $$rr --node_only 1 -q '\x88'$$dq; \
	     ) > full_hyper$*.train 2>&1;		\
	  done

hyper%: training.txt.gz
	perl -le 'BEGIN { srand $*; };			\
	      1; $$eta = 0.1 + 3.9 * rand ();		\
	      1; $$depth = int (11 + 6 * rand ());	\
	      1; $$mc = int (20 + 80 * rand ());	\
	      1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
	      1; $$rr = rand () > 0.5 ? 1 : 0;		\
	      1; $$dq = rand () > 0.5 ? "a" : "b";	\
	      1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$dq;' | \
	while read eta depth mc hyper rr dq;		\
	  do (						\
	    echo $$eta $$depth $$mc $$hyper $$rr $$dq;	\
	    vw --recall_tree $(numlabels) <(zcat $< | sed 's/|/|b/' | head -500000) -b $(bits) --loss_function logistic -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --link glf1 --randomized_routing $$rr --node_only 1 -q '\x88'$$dq; \
	     ) > $@ 2>&1;				\
	  done

log_multi: log_multi.vw testing.txt.gz
	time vw -t -i $^

log_multi.vw: training.txt.gz
	time vw -f $@ --log_multi $(numlabels) $< -b $(bits) --loss_function logistic -l 1 

recall_tree: recall_tree.vw testing.txt.gz
	time vw -t -i $(word 1,$^) <(zcat $(word 2,$^) | sed 's/|/|b/')

recall_tree.vw: training.txt.gz
	time vw -f $@ --recall_tree $(numlabels) <(zcat $< | sed 's/|/|b/') -b $(bits) --loss_function logistic -l 1 --node_only 1 -q '\x88'b #--link glf1 --randomized_routing 1 #$(randomized_routing) 

oaahogwild.vw: training.txt.gz
	time ./do-oaa-hogwild $< -f $@ --oaa $(numlabels) --oaa_subsample 1000 -b $(bits) --loss_function logistic -l 1 

oaahogwild: oaahogwild.vw testing.txt.gz
	(time vw -t -i $^) > $@ 2>&1
	#(time ./do-oaa-hogwild -t -i $^) > $@ 2>&1

timefuoaahogwild: oaahogwild.vw testing.txt.gz
	(time vw -t -i $< <(zcat $(word 2,$^) | head -10000); time vw -t -i $< <(zcat $(word 2,$^) | head -20000)) > $@ 2>&1

=== demo/recall_tree/odp/Makefile ===
SHELL=/bin/zsh

.SECONDARY:

numlabels=105033
bits?=31

odp_train.vw.gz:
	wget --tries=100 -c http://hunch.net/~vw/odp_train.vw.gz

odp_test.vw.gz:
	wget --tries=100 -c http://hunch.net/~vw/odp_test.vw.gz

full_hyper%: full_hyper%.vw odp_test.vw.gz
	time vw -t -i $(word 1,$^) <(zcat $(word 2,$^) | sed 's/|/|b/')

ufull_hyper%.vw: bits=30
ufull_hyper%.vw: odp_train.vw.gz
	perl -le 'BEGIN { srand $*; };			\
	      1; $$eta = 0.1 + 3.9 * rand ();		\
	      1; $$depth = int (12 + 6 * rand ());	\
	      1; $$mc = int (40 + 80 * rand ());	\
	      1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
	      1; $$rr = rand () > 0.5 ? 1 : 0;		\
	      1; $$dq = rand () > 0.5 ? "a" : "b";	\
	      1; $$no = rand () > 0.5 ? "0" : "1";	\
	      1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$dq, $$no;' | \
	while read eta depth mc hyper rr dq no;		\
	  do (						\
	    echo $$eta $$depth $$mc $$hyper $$rr $$dq $$no;	\
	    time vw -f $@ --recall_tree $(numlabels) <((zcat $<; zcat $<; zcat $<; zcat $<; zcat $<) | sed 's/|/|b/' | ./minishuf 100000) -b $(bits) --loss_function logistic -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --link glf1 --randomized_routing $$rr --node_only $$no -q '\x88'$$dq; \
	     ) > $@.train 2>&1;				\
	  done

pfull_hyper%.vw: bits=30
pfull_hyper%.vw: odp_train.vw.gz
	perl -le 'BEGIN { srand $*; };			\
	      1; $$eta = 0.1 + 3.9 * rand ();		\
	      1; $$depth = int (12 + 6 * rand ());	\
	      1; $$mc = int (40 + 80 * rand ());	\
	      1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
	      1; $$rr = rand () > 0.5 ? 1 : 0;		\
	      1; $$dq = rand () > 0.5 ? "a" : "b";	\
	      1; $$no = rand () > 0.5 ? "0" : "1";	\
	      1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$dq, $$no;' | \
	while read eta depth mc hyper rr dq no;		\
	  do (						\
	    echo $$eta $$depth $$mc $$hyper $$rr $$dq $$no;	\
	    time vw -f $@ --recall_tree $(numlabels) <((zcat $<; zcat $<; zcat $<; zcat $<) | sed 's/|/|b/' | ./minishuf 100000) -b $(bits) --loss_function logistic -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --link glf1 --randomized_routing $$rr --node_only $$no -q '\x88'$$dq; \
	     ) > $@.train 2>&1;				\
	  done

mfull_hyper%.vw: bits=30
mfull_hyper%.vw: odp_train.vw.gz
	perl -le 'BEGIN { srand $*; };			\
	      1; $$eta = 0.1 + 3.9 * rand ();		\
	      1; $$depth = int (12 + 6 * rand ());	\
	      1; $$mc = int (40 + 80 * rand ());	\
	      1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
	      1; $$rr = rand () > 0.5 ? 1 : 0;		\
	      1; $$dq = rand () > 0.5 ? "a" : "b";	\
	      1; $$no = rand () > 0.5 ? "0" : "1";	\
	      1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$dq, $$no;' | \
	while read eta depth mc hyper rr dq no;		\
	  do (						\
	    echo $$eta $$depth $$mc $$hyper $$rr $$dq $$no;	\
	    time vw -f $@ --recall_tree $(numlabels) <((zcat $<; zcat $<; zcat $<) | sed 's/|/|b/' | ./minishuf 100000) -b $(bits) --loss_function logistic -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --link glf1 --randomized_routing $$rr --node_only $$no -q '\x88'$$dq; \
	     ) > $@.train 2>&1;				\
	  done

full_hyper%.vw: bits=31
full_hyper%.vw: odp_train.vw.gz
	perl -le 'BEGIN { srand $*; };			\
	      1; $$eta = 0.1 + 3.9 * rand ();		\
	      1; $$depth = int (12 + 6 * rand ());	\
	      1; $$mc = int (40 + 80 * rand ());	\
	      1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
	      1; $$rr = rand () > 0.5 ? 1 : 0;		\
	      1; $$dq = rand () > 0.5 ? "a" : "b";	\
	      1; $$no = rand () > 0.5 ? "0" : "1";	\
	      1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$dq, $$no;' | \
	while read eta depth mc hyper rr dq no;		\
	  do (						\
	    echo $$eta $$depth $$mc $$hyper $$rr $$dq $$no;	\
	    time vw -f $@ --recall_tree $(numlabels) <((zcat $<; zcat $<) | sed 's/|/|b/' | ./minishuf 100000) -b $(bits) --loss_function logistic -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --link glf1 --randomized_routing $$rr --node_only $$no -q '\x88'$$dq; \
	     ) > full_hyper$*.train 2>&1;				\
	  done

hyper%: bits=29
hyper%: odp_train.vw.gz
	perl -le 'BEGIN { srand $*; };			\
	      1; $$eta = 0.1 + 3.9 * rand ();		\
	      1; $$depth = int (8 + 6 * rand ());	\
	      1; $$mc = int (40 + 120 * rand ());	\
	      1; $$log_hyper = log (0.01) + (log (10) - log (0.01)) * rand (); \
	      1; $$rr = rand () > 0.5 ? 1 : 0;		\
	      1; $$dq = rand () > 0.5 ? "a" : "b";	\
	      1; $$no = rand () > 0.5 ? "0" : "1";	\
	      1; print join " ", $$eta, $$depth, $$mc, exp ($$log_hyper), $$rr, $$dq, $$no;' | \
	while read eta depth mc hyper rr dq no;		\
	  do (						\
	    echo $$eta $$depth $$mc $$hyper $$rr $$dq $$no;	\
	    vw --recall_tree $(numlabels) <(zcat $< | sed 's/|/|b/' | ./minishuf 100000) -b $(bits) --loss_function logistic -l $$eta --max_depth $$depth --max_candidates $$mc --bern_hyper $$hyper --link glf1 --randomized_routing $$rr --node_only $$no -q '\x88'$$dq; \
	     ) > $@ 2>&1;				\
	  done

log_multi: log_multi.vw odp_test.vw.gz
	time vw -t -i $^

log_multi.vw: odp_train.vw.gz
	time vw -f $@ --log_multi $(numlabels) $< -b $(bits) --loss_function logistic -l 1 

recall_tree: recall_tree.vw odp_test.vw.gz
	time vw -t -i $(word 1,$^) <(zcat $(word 2,$^) | sed 's/|/|b/')

recall_tree.vw: odp_train.vw.gz
	time vw -f $@ --recall_tree $(numlabels) <(zcat $< | sed 's/|/|b/' | ./minishuf 100000) -b $(bits) --loss_function logistic -l 1 --node_only 1 -q '\x88'b --max_candidates 400 --max_depth 5

oaahogwild.vw: odp_train.vw.gz
	time ./do-oaa-hogwild <(zcat $< | ./minishuf 100000 | gzip -c) -f $@ --oaa $(numlabels) --oaa_subsample 1000 -b $(bits) --loss_function logistic -l 1 

oaahogwild: oaahogwild.vw odp_test.vw.gz
	time ./do-oaa-hogwild $(word 2,$^) -t -i $(word 1,$^)

=== debian/changelog ===
vowpal-wabbit (8.6.1.dfsg1-1~nd18.04+1) bionic; urgency=medium

  * Backported for bionic.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 27 Jul 2018 22:10:28 -0400

vowpal-wabbit (8.6.1.dfsg1-1) unstable; urgency=medium

  * Fresh upstream release
  * debian/patches
    + deb_skip_42 to skip test 42 for now since fails on some 32bit 
      elderlies https://github.com/JohnLangford/vowpal_wabbit/issues/1553

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 27 Jul 2018 19:27:03 -0400

vowpal-wabbit (8.5.0.dfsg1-3) unstable; urgency=medium

  * debian/rules
    - pass the mmx/sse settings only for amd64 and i386 (Closes: #893031)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 16 Mar 2018 15:06:24 -0400

vowpal-wabbit (8.5.0.dfsg1-2) unstable; urgency=medium

  * debian/control
    - add missing markdown and html2text used for README.md generation
  * debian/rules
    - force -msse -mfpmath=sse to provide consistent arithmetics between
      32 and 64 bit x86

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 11 Feb 2018 15:19:14 -0500

=== debian/control ===
Source: vowpal-wabbit
Section: science
Priority: optional
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libboost-program-options-dev,
			   libboost-python-dev,
			   rapidjson-dev,
               help2man,
               markdown,
               html2text,
               zlib1g-dev,
			   markdown, html2text,
Standards-Version: 4.1.3
Homepage: http://hunch.net/~vw/
Vcs-Browser: http://github.com/yarikoptic/vowpal_wabbit
Vcs-Git: git://github.com/yarikoptic/vowpal_wabbit.git -b debian

Package: vowpal-wabbit
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}, libvw0 (= ${binary:Version})
Suggests: vowpal-wabbit-doc
Description: fast and scalable online machine learning algorithm
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing

Package: libvw0
Section: libs
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Description: fast and scalable online machine learning algorithm - dynamic library
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains vowpal-wabbit's dynamic libraries.

Package: libvw-dev
Section: libdevel
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}, libvw0 (= ${binary:Version})
Description: fast and scalable online machine learning algorithm - development files
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains development files needed to compile and link programs
 which use vowpal-wabbit's libraries.

Package: vowpal-wabbit-dbg
Section: debug
Priority: optional
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}, vowpal-wabbit (= ${binary:Version})
Description: fast and scalable online machine learning algorithm - debug files
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains debug symbols for the binaries shipped by vowpal-wabbit
 packages.

Package: vowpal-wabbit-doc
Section: doc
Architecture: all
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Recommends: vowpal-wabbit
Description: fast and scalable online machine learning algorithm - documentation
 Vowpal Wabbit is a fast online machine learning algorithm. The core
 algorithm is specialist gradient descent (GD) on a loss function
 (several are available). VW features:
  - flexible input data specification
  - speedy learning
  - scalability (bounded memory footprint, suitable for distributed
    computation)
  - feature pairing
 .
 This package contains examples (tests) for vowpal-wabbit.
